#include "Napis.h"


Napis::Napis(const char* a)
{
	dl = strlen(a);
	s = new char[dl + 1];
	strcpy(s, a);
}

Napis::~Napis()
{
	if (s)delete[]s;
	s = nullptr;	//s = 0; //s=NULL;
	dl = 0;
}

void Napis::Wypisz() const
{
	cout << s << endl;
}

void Napis::Nadpisz(const char* nowy)
{
	strncpy(s, nowy, dl);
	s[dl] = '\0';
}

void Napis::Nowy(const char* nowy)
{
	delete[]s;
	dl = strlen(nowy);
	s = new char[dl + 1];
	strcpy(s, nowy);
}


void Napis::operator+=(const char* n)
{
	if (n == nullptr || *n == '\0')return;
	if (s == nullptr)
	{
		dl = strlen(n);
		s = new char[dl + 1];
		strcpy(s, n);
	}
	else
	{
		dl += strlen(n);
		char* ns = new char[dl + 1];
		strcpy(ns, s);
		strcat(ns, n);
		delete[]s;
		s = ns;
	}
}


ostream& operator<<(ostream& wy, const Napis& n)
{
	return wy << n.s << endl;
}

//istream& operator>>(istream& we, Napis& n)
//{
//	return we >> n.s; fatalne rozwizanie 
//}
//istream& operator>>(istream& we, Napis& n)
//{
//	char pom[40];
//	we >> pom;
//	n.Nowy(pom);
//	return we;
//}
//istream& operator>>(istream& we, Napis& n)
//{
//	char pom[40];
//	we .get(pom,40);
//	n.Nowy(pom);
//
//	we.ignore(INT_MAX, '\n');
//	
//	return we;
//}
istream& operator>>(istream& we, Napis& n)
{
	char pom[40];
	we.get(pom, 40);
	n.Nowy(pom);

	while (we && we.peek() != '\n')
	{
		we.get(pom, 40);
		n += pom;
	}
	we.get(); // '\n'


	return we;
}

Napis::Napis(const Napis& wzor)
{
	cout << "Konstruktor Kopiujacy\n";

	dl = wzor.dl;
	s = new char[dl + 1];
	strcpy(s, wzor.s);
}

Napis::Napis(Napis&& wzor)noexcept :s(wzor.s), dl(wzor.dl)
{
	cout << "Konstruktor Przenoszacy\n";
	wzor.s = nullptr;
	wzor.dl = 0;
}

Napis& Napis::operator=(const Napis& wzor)
{
	cout<<"Operator =\n";
	if (this != &wzor) // A=A;
	{
		delete[]s;
		dl = wzor.dl;
		s = new char[dl + 1];
		strcpy(s, wzor.s);
	}
	return *this;
}

Napis& Napis::operator=(Napis&& wzor) noexcept
{
	cout << "Operator = przenoszacy\n";
	if (this != &wzor) //A=std::move(A)
	{
		//cz. destruktorowa
		delete[]s;
		//this->~Napis();
		//cz. konstruktor przenoszcy
		//new (this)Napis(std::move(wzor));
		s = wzor.s;
		dl = wzor.dl;
		wzor.s = nullptr;
		wzor.dl = 0;
	}
	return *this;
}

